from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Int, Boolean, String, Float

Drep_Cluster_V0_1_0 = CommandToolBuilder(tool="dRep_cluster", base_command=["dRep", "cluster"], inputs=[ToolInput(tag="in_processors", input_type=Int(optional=True), prefix="--processors", doc=InputDocumentation(doc="threads (default: 6)")), ToolInput(tag="in_debug", input_type=Boolean(optional=True), prefix="--debug", doc=InputDocumentation(doc="make extra debugging output (default: False)")), ToolInput(tag="in_mash_sketch", input_type=Int(optional=True), prefix="--MASH_sketch", doc=InputDocumentation(doc="MASH sketch size (default: 1000)")), ToolInput(tag="in_s_algorithm", input_type=String(optional=True), prefix="--S_algorithm", doc=InputDocumentation(doc="Algorithm for secondary clustering comaprisons:\nfastANI = Kmer-based approach; very fast\nANImf   = (DEFAULT) Align whole genomes with nucmer; filter alignment; compare aligned regions\nANIn    = Align whole genomes with nucmer; compare aligned regions\ngANI    = Identify and align ORFs; compare aligned ORFS\ngoANI   = Open source version of gANI; requires nsmimscan\n(default: ANImf)")), ToolInput(tag="in_n_preset", input_type=String(optional=True), prefix="--n_PRESET", doc=InputDocumentation(doc="Presets to pass to nucmer\ntight   = only align highly conserved regions\nnormal  = default ANIn parameters (default: normal)")), ToolInput(tag="in_p_ani", input_type=Float(optional=True), prefix="--P_ani", doc=InputDocumentation(doc="ANI threshold to form primary (MASH) clusters\n(default: 0.9)")), ToolInput(tag="in_s_ani", input_type=Float(optional=True), prefix="--S_ani", doc=InputDocumentation(doc="ANI threshold to form secondary clusters (default:\n0.99)")), ToolInput(tag="in_skip_mash", input_type=Boolean(optional=True), prefix="--SkipMash", doc=InputDocumentation(doc="Skip MASH clustering, just do secondary clustering on\nall genomes (default: False)")), ToolInput(tag="in_skip_secondary", input_type=Boolean(optional=True), prefix="--SkipSecondary", doc=InputDocumentation(doc="Skip secondary clustering, just perform MASH\nclustering (default: False)")), ToolInput(tag="in_cov_thresh", input_type=Float(optional=True), prefix="--cov_thresh", doc=InputDocumentation(doc="Minmum level of overlap between genomes when doing\nsecondary comparisons (default: 0.1)")), ToolInput(tag="in_coverage_method", input_type=String(optional=True), prefix="--coverage_method", doc=InputDocumentation(doc="Method to calculate coverage of an alignment\n(for ANIn/ANImf only; gANI and fastANI can only do larger method)\ntotal   = 2*(aligned length) / (sum of total genome lengths)\nlarger  = max((aligned length / genome 1), (aligned_length / genome2))\n(default: larger)")), ToolInput(tag="in_cluster_alg", input_type=String(optional=True), prefix="--clusterAlg", doc=InputDocumentation(doc="Algorithm used to cluster genomes (passed to\nscipy.cluster.hierarchy.linkage (default: average)")), ToolInput(tag="in_genomes_cluster_format", input_type=Boolean(optional=True), prefix="-g", doc=InputDocumentation(doc="[GENOMES [GENOMES ...]], --genomes [GENOMES [GENOMES ...]]\ngenomes to cluster in .fasta format. Not necessary if\nalready loaded sequences with the 'filter' operation\n(default: None)\n"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Drep_Cluster_V0_1_0().translate("wdl", allow_empty_container=True)

